<template>

	<div class="flex flex-col pt-2 max-h-full">

		<!-- Header -->
		<div class="text-xl text-center font-bold py-2">
			<template v-if="!uncheckedCount">
				There is currently no item in your list
				<div class="text-sm font-normal">Add a new item by typing in the form below</div>
			</template>
			<template v-else>
				You currently have {{ uncheckedCount }} item{{ uncheckedCount != 1 ? 's' : '' }} in your list
			</template>
		</div>

		<div class="overflow-y-auto">
			<div class="lg:w-1/3 sm:w-2/3 sm:mx-auto mx-2">

				<!-- Unchecked -->
				<div class="my-8">
					<div v-for="(item, index) in uncheckedItems" :key="item.order" class="p-1" :class="{ 'bg-gray-50': index % 2 === 0 }">
						<ShoppingListItem :item="item" @updated="onItemUpdated(item, $event)" @toggled="onItemToggled(item)"></ShoppingListItem>
					</div>
					<div class="mt-4 py-2"> 
						<ShoppingListItem @updated="insertNewItem"></ShoppingListItem>
					</div>
				</div>

				<hr class="my-4" v-if="checkedCount * uncheckedCount > 0" />

				<!-- Checked -->
				<div>
					<div v-for="(item, index) in checkedItems" :key="item.order" class="p-1" :class="{ 'bg-gray-50': index % 2 === 0 }">
						<ShoppingListItem :item="item" @updated="onItemUpdated(item, $event)" @toggled="onItemToggled(item)"></ShoppingListItem>
					</div>
				</div>

			</div>
		</div>

	</div>

</template>

<script setup>
import ShoppingListItem from "./ShoppingListItem.vue";
</script>

<script>
	const storageId = 'LIST';

	const not = fn => (...args) => !fn(...args);

	const capitalize = text => text.split( /\s+/ ).filter( w => w.length ).map( smartCapitalizeWord ).join( ' ' );
	const smartCapitalizeWord = ( word, index ) => index === 0 || word.length > 2 ? capitalizeWord( word ) : word.toLowerCase();
	const capitalizeWord = word => word[0].toUpperCase() + word.slice(1).toLowerCase();

	const isChecked = item => item.checked;
	const sortItems = (a,b) => a.order < b.order ? -1 : 1;

	const load = () => {
		const storageData = sessionStorage.getItem( storageId );
		if ( storageData ) {
			try {
				let items = JSON.parse( storageData );
				return items.sort( sortItems ).map( ( item, order ) => ({ ...item, order }) ); // Compact data on load
			} catch (e) {
				console.error( 'An error occured while loading data from the straoge.', e );
				return null;
			}
		} else {
			return null;
		}
	};
	const save = data => {
		sessionStorage.setItem( storageId, JSON.stringify( data ) );
	};

	const items = load() ?? [
		{ name: 'Formaggio', order: 1 },
		{ name: 'Latte', order: 2 },
		{ name: 'Sushi', checked: true, order: 3 },
		{ name: 'Pomodori', checked: true, order: 4 },
	];

	export default {
		data() {
			return { items };
		},
		computed: {
			checkedItems() { return this.items.filter(isChecked).sort(sortItems); },
			uncheckedItems() { return this.items.filter(not(isChecked)).sort(sortItems); },
			checkedCount() { return this.items.filter(isChecked).length; },
			uncheckedCount() { return this.items.filter(not(isChecked)).length; },
			lastIndex() { return this.items.reduce( (max, cur) => cur.order > max ? cur.order : max, -1 ); },
		},
		methods: {
			insertNewItem(newName) {
				if (newName?.length) {
					newName = capitalize(newName);

					let duplicate = this.items.find(i => i.name === newName);
					if ( !!duplicate ) {
						duplicate.checked = false;
						duplicate.order = this.lastIndex + 1;
					} else {
						this.items.push( { name: newName, order: this.lastIndex + 1 } );
					}
					save(this.items);
				}
			},
			onItemUpdated(item, newName) {
				if (newName?.length > 0) {
					item.name = capitalize(newName);
				} else {
					this.items = this.items.filter(i => i.order !== item.order );
				}
				save(this.items);
			},
			onItemToggled(item) {
				item.checked = !item.checked;
				item.order = this.lastIndex + 1;
				save(this.items);
			}
		}
	};
</script>
